/* Converts Wave100 (a file containing Cave Story melody samples) into WAVs.
 * Implementation 2008-03-30 Jan "Rrrola" Kadlec. Public Domain.
 *
 * Each sample is made of 128 signed 16-bit values (MSB first).
 * C-3 frequency is 33452 Hz (not used by the Org converter).
 */

#include <stdio.h>

int main(void)
{
  char header[] = "RIFF\x24\1\0\0WAVEfmt \x10\0\0\0\1\0\1\0\xAC\x82\0\0\x58\x05\1\0\2\0\x10\0data\0\1\0\0";
  char name[] = "000.wav";
  char buf[256];
  FILE *f = fopen("Wave100", "rb"); if (!f) return -1;

  while (fread(buf, 1, 256, f))
  {
    int i;
    FILE *g = fopen(name, "wb"); if (!g) return -1;
    fwrite(header, 1, 44, g);

    for (i=0; i<256; i+=2)
    { char tmp = buf[i];
      buf[i] = buf[i+1];
      buf[i+1] = tmp;
    }

    fwrite(buf, 1, 256, g);
    fclose(g);

    if (++name[2] > '9')
    { name[2] = '0';
      if (++name[1] > '9') return -1;
    }
  }
  fclose(f);

  return 0;
}
